// Boyer-Moore Algorithm

#include <stdio.h>
#include <string.h>

#include "ss.h"

#define MAX(a, b) ((a > b)? a: b)
void print_badchar(mstring *, long *);

long seek_pattern(mstring *d, mstring *p)
{
    if (stat) printf("bm :");
    if (debug) printf("debug=%d\n", debug);
    if (stat || debug) printf("\n");

    long badchar[NOC];
    memset(badchar, -1, sizeof(long)*NOC);
    for (int i = 0; i < p->length; i++) badchar[(int)(p->text[i])] = i;
    if (debug>1) print_badchar(p, badchar);

    long dp = 0;
    long pp;
    CHALLENGE;
    while(dp <= (d->length - p->length)) {
        pp = p->length - 1;
        if (debug) snap(dp+pp, pp, d->text[dp+pp], p->text[pp]);
        CHALLENGE;
        while(pp >= 0 && p->text[pp] == d->text[dp + pp]) {
            pp--;
            if (debug) snap(dp+pp, pp, d->text[dp+pp], p->text[pp]);
            CHALLENGE;
        }
        if (pp < 0) { // 発見した
            stats(dp);
            if (!cont) return (dp);
            dp += (dp + p->length < d->length) ? p->length - badchar[d->text[dp + p->length]] : 1;
        } else
            dp += MAX(1, pp - badchar[d->text[dp + pp]]);
    }
    return (-1);
}

void print_badchar(mstring *p, long *badchar) {
    printf("badchar tables:\n");
    for (int i = 0; i < NOC; i++)
        if (badchar[i]>-1) printf("%2x %c %3ld\n", i, (i>0x1f && i<0x7f ? (char)(i) : '_'), badchar[i]);
    printf("\n");
}
