// Knuth-Morris-Pratt method pattern match

#include <stdio.h>

#include "ss.h"

void compute_prefix_function(mstring *, long *);
void print_pi(mstring *, long *);

long seek_pattern(mstring *d, mstring *p) {
    if (stat) printf("kmp:");
    if (debug) printf("debug=%d", debug);
    if (stat || debug) printf("\n");

    long pi[p->length]; // LPS Function
    compute_prefix_function(p, pi);
    if (debug>1) print_pi(p, pi);
    long dp = 0, pp = 0; // domain, patternのどこの文字に注目しているか
    while (dp < d->length) {
        int dpp=dp;
        CHALLENGE;
        if (debug) snap(dp, pp, d->text[dp], p->text[pp]);
        if (p->text[pp] == d->text[dp]) {
            pp++;
            dp++;
        }
        if (pp == p->length) { // 発見した
            stats(dp-pp);
            if (!cont) return (dp-pp);
            pp = pi[pp-1];
        } else if (dp < d->length && p->text[pp] != d->text[dp]) {
            if (debug && dp!=dpp) snap(dp, pp, d->text[dp], p->text[pp]);
            if (pp) pp = pi[pp-1];
            else dp++;
        }
    }
    return (-1);
}

void compute_prefix_function(mstring *p, long *pi) {
    long l = 0;
    pi[0] = 0; // LPS(longest proper prefix that is also a suffix)
    for (long i=1; i < p->length; ) {
        if (p->text[i] == p->text[l])
            pi[i++] = ++l;
        else {
            if (l) l = pi[l-1];
            else pi[i++] = 0;
        }
    }
}

void print_pi(mstring *p, long *pi) {
    printf("pi:\n");
    for ( int i=0; i < p->length; i++ )
        printf("%c : %ld\n", p->text[i], pi[i]);
    printf("\n");
}
