// Rabin-Karp algorithm

#include<stdio.h>

#include "ss.h"
  
#define PRIME 101 // 素数
  
long seek_pattern(mstring *d, mstring *p)
{
    if (stat) printf("rk :");
    if (debug) printf("debug=%d", debug);
    if (stat || debug) printf("\n");

    long dp, pp;
    int hp = 0; // hash value for pattern
    int hd = 0; // hash value for domain
    int h = 1;
    int i;
  
    for (i=0; i < p->length - 1; i++) {
        h = (h << S) % PRIME; // h = NOC^(p->length-1) % PRIME
        hp = ((hp << S) + p->text[i]) % PRIME;
        hd = ((hd << S) + d->text[i]) % PRIME;
    }
    hp = ((hp << S) + p->text[i]) % PRIME;
    hd = ((hd << S) + d->text[i]) % PRIME;
  
    for (dp = 0; dp < d->length - p->length; dp++) {
        if ( hp == hd ) {
            for (pp = 0; pp < p->length; pp++) {
                if (debug>1) putchar('!');
                CHALLENGE;
                if (debug>0) snap(dp+pp, pp, d->text[dp+pp], p->text[pp]);
                if (d->text[dp+pp] != p->text[pp]) break;
            }
            if (pp == p->length) { // 発見した
                stats(dp);
                if (!cont) return (dp);
            }
        }
        if (debug>1) {
            CHALLENGE;
            snap(dp, 0, d->text[dp], p->text[0]);
        }
        hd = (((hd - d->text[dp] * h) << S) + d->text[dp + p->length]) % PRIME;
        if (hd < 0) hd = (hd + PRIME);
    }
    if ( hp == hd ) {
        for (pp = 0; pp < p->length; pp++) {
            CHALLENGE;
            if (debug>0) snap(dp+pp, pp, d->text[dp+pp], p->text[pp]);
            if (d->text[dp+pp] != p->text[pp]) break;
        }
        if (pp == p->length) { // 発見した
                stats(dp);
                if (!cont) return(dp);
        }
    }
    return (-1);
}
