// 2022-6-26

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <unistd.h>
#include "ss.h"

char *cmd;
void usage_exit(char *);
mstring *read_text(char *);

long seek_pattern(mstring *, mstring *);

int main(int argc, char **argv)
{
    int opt;
    cmd=argv[0];
    char mesg[256];
    while ((opt = getopt(argc, argv, ":dsc")) != -1) {
        switch (opt) {
            case 'd': debug++; break;
            case 's': stat++; break;
            case 'c': cont++; break;
            default:
                    sprintf(mesg, "wrong option: %c", opt);
                    usage_exit(mesg);
        }
    }
    // printf("argc=%d, optind=%d\n", argc, optind);
    argc -= optind;
    argv += (optind-1);

    if (argc < 2) {
        sprintf(mesg, "argc=%d", argc);
        usage_exit(mesg);
    }
    // printf("argc=%d, argv[1]=%s, argv[2]=%s\n", argc, argv[1], argv[2]);

    mstring *dom;
    mstring *pat = malloc(sizeof(mstring));
    pat->text = (unsigned char *)argv[1];
    pat->length = strlen(argv[1]);
    dom = read_text(argv[2]);

    if (dom->length < pat->length) {
        sprintf(mesg, "never match: %ld < %ld", dom->length, pat->length);
        usage_exit(mesg);
    }
    if (!pat->length) {
        printf("null pattern\n");
        exit(0);
    }

    long pos = seek_pattern(dom, pat);
    if (stat) {
        printf("domain_size=%ld, pattern_size=%ld, %ld challenges\n",
                dom->length, pat->length, challenged);
    }
    if (cont) printf("%ld matched.\n", count);
    if (!count) exit(1);
    exit(0);
}

void usage_exit(char *s)
{
    fprintf(stderr, "error: %s\n", s);
    fprintf(stderr, "      %s [-dsc] \"PATTERN\" FILE\n", cmd);
    exit(2);
}

mstring *read_text(char *fn)
{
    mstring *str = malloc(sizeof(mstring));
    FILE *f;
    char mesg[256];
    if (! (f = fopen(fn, "r"))) {
        sprintf(mesg, "%s : open failed", fn);
        usage_exit(mesg);
    }
    fseek(f, 0, SEEK_END);
    long fsize = ftell(f);
    fseek(f, 0, SEEK_SET);
    str->length = fsize;
    str->text = malloc(fsize + 1);
    fread(str->text, fsize, 1, f);
    fclose(f);
    str->text[fsize] = 0;
    return str;
}

